routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\PostController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\UserController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::middleware(['auth:sanctum', 'verified'])->group( function (){
    Route::resource('posts', PostController::class);
    Route::resource('categories', CategoryController::class);
    Route::resource('roles', RoleController::class);
    Route::resource('permissions', PermissionController::class);
    Route::resource('users', UserController::class);
    Route::get('dashboard' , function (){
        return view('dashboard');
    })->name('dashboard');
});
Route::get('createrole', [RoleController::class, 'createRole']);
Route::get('assignrole',[RoleController::class, 'assignRole']);
//Route::get('createpermission', [PermissionController::class, 'createPermission']);

app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    use HasFactory;
    protected $fillable = [
        'title',
        'description',
        'image',
        'published',
        'category_id',
    ];

    public const Status = [
        1 => 'منتشر شده',
        0 => 'در صف انتشار'
    ];

    public function category()
    {
        return $this->belongsTo(Category::class);
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Repositories\Post\PostRepository;
use App\Http\Requests\Post\UpdatePostRequest;
use App\Http\Requests\Post\CreatePostRequest;
use App\Models\Post;
use App\Models\Category;

class PostController extends Controller
{
    protected $repository;

    public function __construct(PostRepository $repository)
    {
        $this->repository = $repository;
//        $this->middleware('permission:write post')->only('create');
//        $this->middleware('permission:edit post')->only('edit');
//        $this->middleware('permission:publish post')->only('destroy');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $posts = $this->repository->all();
        return view('posts.index', ['posts' => $posts]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $status = Post::Status;
        return view('posts.create', compact('status'))->with(['categories' => Category::all()]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(CreatePostRequest $request)
    {
        $this->repository->create($request->all());
        session()->flash('success', 'Create Post Has Been Successful');
        return redirect()->route('posts.index');
    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $this->repository->find($id);
        return view(route('posts.create'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(UpdatePostRequest $request, $id)
    {
        $this->repository->update($request->all(), $id);
        session()->flash('success', 'Update Post Has Been Successfully');
        return redirect()->route('posts.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $this->repository->delete($id);
        session()->flash('danger', 'Post Has Been Deleted');
        return redirect()->route('posts.index');
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

resources/views/posts/create.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Posts') }}
        </h2>
    </x-slot>

    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-xl sm:rounded-lg">
                <div class="card card-default">
                    <div class="card-header header-Title">
                        {{isset($post)?'Edit Post':'Create Post'}}
                    </div>
                    <div class="card-body">
                        @if($errors->any())
                            <div class="alert alert-danger">
                                <ul class="list-group">
                                    @foreach($errors->all() as $error)
                                        <li class="list-group-item text-danger">
                                            {{ $error }}
                                        </li>
                                    @endforeach
                                </ul>
                            </div>
                        @endif
                        <form action="{{isset($post)? route('posts.update',$post->id): route('posts.store')}}" method="POST" enctype="multipart/form-data" class="animated fadeInUp">
                            @csrf
                            @if(isset($post))
                                @method('PUT')
                            @endif
                            <div class="form-group">
                                <label for="title">Title</label>
                                <input placeholder="Enter Title" type="text" id="title" class="form-control" name="title" value="{{isset($post) ? $post->title:''}}">
                            </div>
                            <div class="form-group">
                                <label for="description">Description</label>
                                <textarea placeholder="Enter Description" name="description" id="description" rows="5" cols="5" class="form-control">{{isset($post) ? $post->description : ''}}</textarea>
                            </div>
                            @if(isset($post))
                                @can('publish post')
                                    <div class="form-group">
                                        {{ Form::label('status', 'Status')}}
                                        {{ Form::select('published',$status , old('published') ,['class'=>'form-group']) }}
                                        {{--                                        <label for="published">status</label>--}}
                                        {{--                                        @foreach($status as $statuses)--}}
                                        {{--                                            <label>{{$statuses}}<input value="{{isset($statuses)? $statuses:''}}" type="checkbox" class="form-group"></label>--}}
                                        {{--                                        @endforeach--}}
                                    </div>
                                @endcan
                            @endif
                            <div class="form-group">
                                <label for="image">Image</label>
                                <input type="file" id="image" class="form-control" name="image" value="">
                            </div>
                            @if(isset($post))
                                <div class="form-group">
                                    <img src="{{asset('storage/'.$post->image)}}" style="width: 10%" alt="">
                                </div>
                            @endif
                            <div class="form-group">
                                <label for="category">Category</label>
                                <select name="category_id" id="category" class="form-group">
                                    @foreach($categories as $category)
                                        @if(isset($post))
                                            <option value="{{$category->id}}" @if($category->id == $post->category_id) selected="selected" @else value="{{$category->id}}" @endif>{{$category->name}} </option>
                                        @else
                                            <option value="{{$category->id}}">{{$category->name}}</option>
                                        @endif
                                    @endforeach
                                </select>
                            </div>

                            <div class="form-group">
                                <button type="submit" class="btn btn-success">
                                    {{isset($post) ? 'Edit Post':'Create Post'}}
                                </button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/posts/index.blade.php
<x-app-layout>
    <x-slot name="header">

        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Posts') }}
        </h2>
    </x-slot>

    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-xl sm:rounded-lg">
                <div class="d-flex justify-content-end mb2">
{{--                    @can('write post')--}}
                        <a class="btn btn-success" href="{{route('posts.create')}}">
                            Create Post
                        </a>
{{--                    @endcan--}}
                </div>
                <div class="card card-default">
                    {{--                        <div class="card-header">پست ها</div>--}}
                    <div class="card-body">
                        {{ Widget::run('post_list') }}
                    </div>

                </div>

            </div>
        </div>
    </div>
</x-app-layout>